<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE mapper PUBLIC "-//mybatis.org//DTD Mapper 3.0//EN"
"mybatis-3-mapper.dtd">
<mapper namespace="com.mortals.xhx.module.app.dao.ibatis.AppPublishDaoImpl">

    <!-- 字段和属性映射 -->
    <resultMap type="AppPublishEntity" id="AppPublishEntity-Map">
            <id  property="id" column="id" />
            <result property="appCode" column="appCode" />
            <result property="appName" column="appName" />
            <result property="filePath" column="filePath" />
            <result property="distributeFilePath" column="distributeFilePath" />
            <result property="appType" column="appType" />
            <result property="distribute" column="distribute" />
            <result property="version" column="version" />
            <result property="createTime" column="createTime" />
            <result property="updateUserId" column="updateUserId" />
            <result property="updateTime" column="updateTime" />
            
    </resultMap>


    <!-- 表所有列 -->
    <sql id="_columns">
        <trim suffixOverrides="," suffix="">
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('id') or colPickMode == 1 and data.containsKey('id')))">
                    a.id,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appCode') or colPickMode == 1 and data.containsKey('appCode')))">
                    a.appCode,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appName') or colPickMode == 1 and data.containsKey('appName')))">
                    a.appName,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('filePath') or colPickMode == 1 and data.containsKey('filePath')))">
                    a.filePath,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('distributeFilePath') or colPickMode == 1 and data.containsKey('distributeFilePath')))">
                    a.distributeFilePath,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('appType') or colPickMode == 1 and data.containsKey('appType')))">
                    a.appType,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('distribute') or colPickMode == 1 and data.containsKey('distribute')))">
                    a.distribute,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('version') or colPickMode == 1 and data.containsKey('version')))">
                    a.version,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('createTime') or colPickMode == 1 and data.containsKey('createTime')))">
                    a.createTime,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateUserId') or colPickMode == 1 and data.containsKey('updateUserId')))">
                    a.updateUserId,
                </if>
                <if test="(data == null) or (data != null and ( colPickMode == 0 and !data.containsKey('updateTime') or colPickMode == 1 and data.containsKey('updateTime')))">
                    a.updateTime,
                </if>
        </trim>
    </sql>
    <!-- 新增 区分主键自增加还是业务插入 -->
    <insert id="insert" parameterType="AppPublishEntity"  useGeneratedKeys="true" keyProperty="id">
        insert into mortals_xhx_app_publish
        (appCode,appName,filePath,distributeFilePath,appType,distribute,version,createTime,updateUserId,updateTime)
        VALUES
        (#{appCode},#{appName},#{filePath},#{distributeFilePath},#{appType},#{distribute},#{version},#{createTime},#{updateUserId},#{updateTime})
    </insert>

    <!-- 批量新增 -->
    <insert id="insertBatch" parameterType="paramDto">
        insert into mortals_xhx_app_publish
        (appCode,appName,filePath,distributeFilePath,appType,distribute,version,createTime,updateUserId,updateTime)
        VALUES
        <foreach collection="data.dataList" item="item" index="index" separator="," >
            (#{item.appCode},#{item.appName},#{item.filePath},#{item.distributeFilePath},#{item.appType},#{item.distribute},#{item.version},#{item.createTime},#{item.updateUserId},#{item.updateTime})
        </foreach>
    </insert>


    <!-- 根据ParamDto更新 -->
    <update id="update" parameterType="paramDto">
        update mortals_xhx_app_publish as a
        set
        <trim suffixOverrides="," suffix="">
            <if test="(colPickMode==0 and data.containsKey('appCode')) or (colPickMode==1 and !data.containsKey('appCode'))">
                a.appCode=#{data.appCode},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appName')) or (colPickMode==1 and !data.containsKey('appName'))">
                a.appName=#{data.appName},
            </if>
            <if test="(colPickMode==0 and data.containsKey('filePath')) or (colPickMode==1 and !data.containsKey('filePath'))">
                a.filePath=#{data.filePath},
            </if>
            <if test="(colPickMode==0 and data.containsKey('distributeFilePath')) or (colPickMode==1 and !data.containsKey('distributeFilePath'))">
                a.distributeFilePath=#{data.distributeFilePath},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appType')) or (colPickMode==1 and !data.containsKey('appType'))">
                a.appType=#{data.appType},
            </if>
            <if test="(colPickMode==0 and data.containsKey('appTypeIncrement')) or (colPickMode==1 and !data.containsKey('appTypeIncrement'))">
                a.appType=ifnull(a.appType,0) + #{data.appTypeIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('distribute')) or (colPickMode==1 and !data.containsKey('distribute'))">
                a.distribute=#{data.distribute},
            </if>
            <if test="(colPickMode==0 and data.containsKey('distributeIncrement')) or (colPickMode==1 and !data.containsKey('distributeIncrement'))">
                a.distribute=ifnull(a.distribute,0) + #{data.distributeIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('version')) or (colPickMode==1 and !data.containsKey('version'))">
                a.version=#{data.version},
            </if>
            <if test="(colPickMode==0 and data.containsKey('createTime')) or (colPickMode==1 and !data.containsKey('createTime'))">
                a.createTime=#{data.createTime},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserId')) or (colPickMode==1 and !data.containsKey('updateUserId'))">
                a.updateUserId=#{data.updateUserId},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !data.containsKey('updateUserIdIncrement'))">
                a.updateUserId=ifnull(a.updateUserId,0) + #{data.updateUserIdIncrement},
            </if>
            <if test="(colPickMode==0 and data.containsKey('updateTime')) or (colPickMode==1 and !data.containsKey('updateTime'))">
                a.updateTime=#{data.updateTime},
            </if>
        </trim>
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </update>
    <!-- 批量更新 -->
    <update id="updateBatch" parameterType="paramDto">
        update mortals_xhx_app_publish as a
        <trim prefix="set" suffixOverrides=",">
                <trim prefix="appCode=(case" suffix="ELSE appCode end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('appCode')) or (colPickMode==1 and !item.containsKey('appCode'))">
                            when a.id=#{item.id} then #{item.appCode}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="appName=(case" suffix="ELSE appName end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('appName')) or (colPickMode==1 and !item.containsKey('appName'))">
                            when a.id=#{item.id} then #{item.appName}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="filePath=(case" suffix="ELSE filePath end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('filePath')) or (colPickMode==1 and !item.containsKey('filePath'))">
                            when a.id=#{item.id} then #{item.filePath}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="distributeFilePath=(case" suffix="ELSE distributeFilePath end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('distributeFilePath')) or (colPickMode==1 and !item.containsKey('distributeFilePath'))">
                            when a.id=#{item.id} then #{item.distributeFilePath}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="appType=(case" suffix="ELSE appType end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('appType')) or (colPickMode==1 and !item.containsKey('appType'))">
                                        when a.id=#{item.id} then #{item.appType}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('appTypeIncrement')) or (colPickMode==1 and !item.containsKey('appTypeIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.appType,0) + #{item.appTypeIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                        <trim prefix="distribute=(case" suffix="ELSE distribute end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('distribute')) or (colPickMode==1 and !item.containsKey('distribute'))">
                                        when a.id=#{item.id} then #{item.distribute}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('distributeIncrement')) or (colPickMode==1 and !item.containsKey('distributeIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.distribute,0) + #{item.distributeIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="version=(case" suffix="ELSE version end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('version')) or (colPickMode==1 and !item.containsKey('version'))">
                            when a.id=#{item.id} then #{item.version}
                        </if>
                    </foreach>
                </trim>
                <trim prefix="createTime=(case" suffix="ELSE createTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('createTime')) or (colPickMode==1 and !item.containsKey('createTime'))">
                            when a.id=#{item.id} then #{item.createTime}
                        </if>
                    </foreach>
                </trim>
                        <trim prefix="updateUserId=(case" suffix="ELSE updateUserId end),">
                            <foreach collection="data.dataList" item="item" index="index" separator="" >
                                <choose>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserId')) or (colPickMode==1 and !item.containsKey('updateUserId'))">
                                        when a.id=#{item.id} then #{item.updateUserId}
                                    </when>
                                    <when test="(colPickMode==0 and item.containsKey('updateUserIdIncrement')) or (colPickMode==1 and !item.containsKey('updateUserIdIncrement'))">
                                        when a.id=#{item.id} then ifnull(a.updateUserId,0) + #{item.updateUserIdIncrement}
                                    </when>
                                </choose>
                            </foreach>
                        </trim>
                <trim prefix="updateTime=(case" suffix="ELSE updateTime end),">
                    <foreach collection="data.dataList" item="item" index="index" separator="" >
                        <if test="(colPickMode==0 and item.containsKey('updateTime')) or (colPickMode==1 and !item.containsKey('updateTime'))">
                            when a.id=#{item.id} then #{item.updateTime}
                        </if>
                    </foreach>
                </trim>
        </trim>
        where id in
        <foreach collection="data.dataList" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </update>
    <!-- 根据主健查询 -->
    <select id="getByKey" parameterType="paramDto" resultMap="AppPublishEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_app_publish as a
        where a.id=#{condition.id}
    </select>
    <!-- 根据主健删除 -->
    <delete id="deleteByKey" parameterType="paramDto">
        delete a.* from mortals_xhx_app_publish as a where a.id=#{condition.id}
    </delete>
    <!-- 根据主健删除一批，针对单一主健有效 -->
    <delete id="deleteByKeys">
        delete from mortals_xhx_app_publish where id in
        <foreach collection="array" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>
    <!-- 根据主健列表删除一批，针对单一主健有效 -->
    <delete id="deleteByKeyList">
        delete from mortals_xhx_app_publish where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item}
        </foreach>
    </delete>

    <!-- 根据对象列表删除一批，针对单一主健有效 -->
    <delete id="deleteByEntityList">
        delete from mortals_xhx_app_publish where id in
        <foreach collection="list" item="item" index="index" open="(" separator="," close=")">
            #{item.id}
        </foreach>
    </delete>
    <!-- 根据paramDto删除一批 -->
    <delete id="deleteByMap" parameterType="paramDto">
        delete a.* from mortals_xhx_app_publish as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </delete>
    <!-- 获取列表 -->
    <select id="getList" parameterType="paramDto" resultMap="AppPublishEntity-Map">
        select <include refid="_columns"/>
        from mortals_xhx_app_publish as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
        <include refid="_orderCols_"/>
    </select>



    <!-- 获取 -->
    <select id="getListCount" parameterType="paramDto" resultType="int">
        select count(1)
        from mortals_xhx_app_publish as a
        <trim suffixOverrides="where" suffix="">
            where
            <trim prefixOverrides="and" prefix="">
                <include refid="_condition_"/>
            </trim>
        </trim>
    </select>
    <!-- 条件映射 -->
    <sql id="_condition_">
        <if test="condition != null and !condition.isEmpty()">
            <!-- 条件映射-普通条件 -->
            <include refid="_condition_param_">
                <property name="_conditionParam_" value="condition"/>
                <property name="_conditionType_" value="and"/>
            </include>
            <!-- 条件映射-集合之间使用AND，集合中元素使用OR-(list[0].1 or list[0].2) and (list[1].3 or list[1].4) -->
            <if test="condition.containsKey('andConditionList') and !condition.andConditionList.isEmpty()">
                and
                <foreach collection="condition.andConditionList" open="(" close=")" index="index" item="andCondition" separator=" and ">
                    <trim prefixOverrides="or" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="andCondition"/>
                            <property name="_conditionType_" value="or"/>
                        </include>
                    </trim>
                </foreach>
            </if>
            <!-- 条件映射-集合之间使用OR，集合中元素使用AND-(list[0].1 and list[0].2) or (list[1].3 and list[1].4) -->
            <if test="condition.containsKey('orConditionList') and !condition.orConditionList.isEmpty()">
                and
                <foreach collection="condition.orConditionList" open="(" close=")" index="index" item="orCondition" separator=" or ">
                    <trim prefixOverrides="and" prefix="(" suffix=")">
                        <include refid="_condition_param_">
                            <property name="_conditionParam_" value="orCondition"/>
                            <property name="_conditionType_" value="and"/>
                        </include>
                    </trim>
                </foreach>
            </if>
        </if>
    </sql>
    <!-- 条件映射-代参数 -->
    <sql id="_condition_param_">
        <bind name="conditionParamRef" value="${_conditionParam_}"/>
        <if test="conditionParamRef.containsKey('id')">
            <if test="conditionParamRef.id != null">
                ${_conditionType_} a.id=#{${_conditionParam_}.id}
            </if>
        </if>
            <if test="conditionParamRef.containsKey('id')">
                <if test="conditionParamRef.id != null ">
                    ${_conditionType_} a.id = #{${_conditionParam_}.id}
                </if>
                <if test="conditionParamRef.id == null">
                    ${_conditionType_} a.id is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('idList')">
                ${_conditionType_} a.id in
                <foreach collection="conditionParamRef.idList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('idStart') and conditionParamRef.idStart != null">
                ${_conditionType_} a.id <![CDATA[ >= ]]> #{${_conditionParam_}.idStart}
            </if>
            <if test="conditionParamRef.containsKey('idEnd') and conditionParamRef.idEnd != null">
                ${_conditionType_} a.id <![CDATA[ <= ]]> #{${_conditionParam_}.idEnd}
            </if>


            <if test="conditionParamRef.containsKey('appCode')">
                <if test="conditionParamRef.appCode != null and conditionParamRef.appCode != ''">
                    ${_conditionType_} a.appCode like #{${_conditionParam_}.appCode}
                </if>
                <if test="conditionParamRef.appCode == null">
                    ${_conditionType_} a.appCode is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('appCodeList')">
                ${_conditionType_} a.appCode in
                <foreach collection="conditionParamRef.appCodeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('appName')">
                <if test="conditionParamRef.appName != null and conditionParamRef.appName != ''">
                    ${_conditionType_} a.appName like #{${_conditionParam_}.appName}
                </if>
                <if test="conditionParamRef.appName == null">
                    ${_conditionType_} a.appName is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('appNameList')">
                ${_conditionType_} a.appName in
                <foreach collection="conditionParamRef.appNameList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('filePath')">
                <if test="conditionParamRef.filePath != null and conditionParamRef.filePath != ''">
                    ${_conditionType_} a.filePath like #{${_conditionParam_}.filePath}
                </if>
                <if test="conditionParamRef.filePath == null">
                    ${_conditionType_} a.filePath is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('filePathList')">
                ${_conditionType_} a.filePath in
                <foreach collection="conditionParamRef.filePathList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('distributeFilePath')">
                <if test="conditionParamRef.distributeFilePath != null and conditionParamRef.distributeFilePath != ''">
                    ${_conditionType_} a.distributeFilePath like #{${_conditionParam_}.distributeFilePath}
                </if>
                <if test="conditionParamRef.distributeFilePath == null">
                    ${_conditionType_} a.distributeFilePath is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('distributeFilePathList')">
                ${_conditionType_} a.distributeFilePath in
                <foreach collection="conditionParamRef.distributeFilePathList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('appType')">
                <if test="conditionParamRef.appType != null ">
                    ${_conditionType_} a.appType = #{${_conditionParam_}.appType}
                </if>
                <if test="conditionParamRef.appType == null">
                    ${_conditionType_} a.appType is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('appTypeList')">
                ${_conditionType_} a.appType in
                <foreach collection="conditionParamRef.appTypeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('appTypeStart') and conditionParamRef.appTypeStart != null">
                ${_conditionType_} a.appType <![CDATA[ >= ]]> #{${_conditionParam_}.appTypeStart}
            </if>
            <if test="conditionParamRef.containsKey('appTypeEnd') and conditionParamRef.appTypeEnd != null">
                ${_conditionType_} a.appType <![CDATA[ <= ]]> #{${_conditionParam_}.appTypeEnd}
            </if>

            <if test="conditionParamRef.containsKey('distribute')">
                <if test="conditionParamRef.distribute != null ">
                    ${_conditionType_} a.distribute = #{${_conditionParam_}.distribute}
                </if>
                <if test="conditionParamRef.distribute == null">
                    ${_conditionType_} a.distribute is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('distributeList')">
                ${_conditionType_} a.distribute in
                <foreach collection="conditionParamRef.distributeList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('distributeStart') and conditionParamRef.distributeStart != null">
                ${_conditionType_} a.distribute <![CDATA[ >= ]]> #{${_conditionParam_}.distributeStart}
            </if>
            <if test="conditionParamRef.containsKey('distributeEnd') and conditionParamRef.distributeEnd != null">
                ${_conditionType_} a.distribute <![CDATA[ <= ]]> #{${_conditionParam_}.distributeEnd}
            </if>


            <if test="conditionParamRef.containsKey('version')">
                <if test="conditionParamRef.version != null and conditionParamRef.version != ''">
                    ${_conditionType_} a.version like #{${_conditionParam_}.version}
                </if>
                <if test="conditionParamRef.version == null">
                    ${_conditionType_} a.version is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('versionList')">
                ${_conditionType_} a.version in
                <foreach collection="conditionParamRef.versionList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>

            <if test="conditionParamRef.containsKey('createTime')">
                <if test="conditionParamRef.createTime != null ">
                    ${_conditionType_} a.createTime = #{${_conditionParam_}.createTime}
                </if>
                <if test="conditionParamRef.createTime == null">
                    ${_conditionType_} a.createTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('createTimeStart') and conditionParamRef.createTimeStart != null and conditionParamRef.createTimeStart!=''">
                ${_conditionType_} a.createTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('createTimeEnd') and conditionParamRef.createTimeEnd != null and conditionParamRef.createTimeEnd!=''">
                ${_conditionType_} a.createTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.createTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateUserId')">
                <if test="conditionParamRef.updateUserId != null ">
                    ${_conditionType_} a.updateUserId = #{${_conditionParam_}.updateUserId}
                </if>
                <if test="conditionParamRef.updateUserId == null">
                    ${_conditionType_} a.updateUserId is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdList')">
                ${_conditionType_} a.updateUserId in
                <foreach collection="conditionParamRef.updateUserIdList" open="(" close=")" index="index" item="item" separator=",">
                    #{item}
                </foreach>
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdStart') and conditionParamRef.updateUserIdStart != null">
                ${_conditionType_} a.updateUserId <![CDATA[ >= ]]> #{${_conditionParam_}.updateUserIdStart}
            </if>
            <if test="conditionParamRef.containsKey('updateUserIdEnd') and conditionParamRef.updateUserIdEnd != null">
                ${_conditionType_} a.updateUserId <![CDATA[ <= ]]> #{${_conditionParam_}.updateUserIdEnd}
            </if>


            <if test="conditionParamRef.containsKey('updateTime')">
                <if test="conditionParamRef.updateTime != null ">
                    ${_conditionType_} a.updateTime = #{${_conditionParam_}.updateTime}
                </if>
                <if test="conditionParamRef.updateTime == null">
                    ${_conditionType_} a.updateTime is null
                </if>
            </if>
            <if test="conditionParamRef.containsKey('updateTimeStart') and conditionParamRef.updateTimeStart != null and conditionParamRef.updateTimeStart!=''">
                ${_conditionType_} a.updateTime <![CDATA[ >= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeStart},' 00:00:00'),19),'%Y-%m-%d %k:%i:%s')
            </if>
            <if test="conditionParamRef.containsKey('updateTimeEnd') and conditionParamRef.updateTimeEnd != null and conditionParamRef.updateTimeEnd!=''">
                ${_conditionType_} a.updateTime <![CDATA[ <= ]]> STR_TO_DATE(left(concat(#{${_conditionParam_}.updateTimeEnd},' 23:59:59'),19),'%Y-%m-%d %k:%i:%s')
            </if>
    </sql>
    <sql id="_orderCols_">
        <if test="orderColList != null and !orderColList.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                <foreach collection="orderColList" open="" close="" index="index" item="item" separator=",">
                     ${item.colName} ${item.sortKind}
                </foreach>
            </trim>
        </if>
        <if test="(orderColList == null or orderColList.isEmpty()) and orderCol != null and !orderCol.isEmpty()">
            order by
            <trim suffixOverrides=","  suffix="">
                    <if test="orderCol.containsKey('id')">
                        a.id
                        <if test='orderCol.id != null and "DESC".equalsIgnoreCase(orderCol.id)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('appCode')">
                        a.appCode
                        <if test='orderCol.appCode != null and "DESC".equalsIgnoreCase(orderCol.appCode)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('appName')">
                        a.appName
                        <if test='orderCol.appName != null and "DESC".equalsIgnoreCase(orderCol.appName)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('filePath')">
                        a.filePath
                        <if test='orderCol.filePath != null and "DESC".equalsIgnoreCase(orderCol.filePath)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('distributeFilePath')">
                        a.distributeFilePath
                        <if test='orderCol.distributeFilePath != null and "DESC".equalsIgnoreCase(orderCol.distributeFilePath)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('appType')">
                        a.appType
                        <if test='orderCol.appType != null and "DESC".equalsIgnoreCase(orderCol.appType)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('distribute')">
                        a.distribute
                        <if test='orderCol.distribute != null and "DESC".equalsIgnoreCase(orderCol.distribute)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('version')">
                        a.version
                        <if test='orderCol.version != null and "DESC".equalsIgnoreCase(orderCol.version)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('createTime')">
                        a.createTime
                        <if test='orderCol.createTime != null and "DESC".equalsIgnoreCase(orderCol.createTime)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateUserId')">
                        a.updateUserId
                        <if test='orderCol.updateUserId != null and "DESC".equalsIgnoreCase(orderCol.updateUserId)'>DESC</if>
                        ,
                    </if>
                    <if test="orderCol.containsKey('updateTime')">
                        a.updateTime
                        <if test='orderCol.updateTime != null and "DESC".equalsIgnoreCase(orderCol.updateTime)'>DESC</if>
                        ,
                    </if>
            </trim>
        </if>
    </sql>
    <sql id="_group_by_">
        <if test="groupList != null and !groupList.isEmpty()">
            GROUP BY
            <trim suffixOverrides=","  suffix="">
                <foreach collection="groupList" open="" close="" index="index" item="item" separator=",">
                    ${item}
                </foreach>
            </trim>
        </if>
    </sql>
</mapper>